#include <GL/glut.h>
#include <stdlib.h>
#include "Audio.h"

#include "GameSession.h"
#include "GameIntro.h"
#include "extern.h"
#include "utility.h"

#ifdef _WIN32
#define drand48() (((float) rand())/((float) RAND_MAX))
#define srand48(x) (srand((x)))
#endif

GameIntro::GameIntro()
{
  Title.Open("data/title.raw");
	Title.Flip();
	A.resize(AstNum);
		for(int i=0;i<AstNum;i++)
		{
			A[i]=new Ast3DFract("data/tetra.raw",Ast::LargeSize);
			A[i]->p.x()=(drand48()-0.5)*1000;	
			A[i]->p.y()=(drand48()-0.5)*1000;	
			A[i]->p.z()=-800;
			A[i]->v.z()=200;
			A[i]->av=20+drand48()*70;
			A[i]->axis=Normalize(Point3f(drand48(),drand48(),drand48()));
		}
}

/// This function clip the position of an object against the ViewFrustum
void GameIntro::Clip(Point3f &p)
  {
	 if(p.x() > 200-p.z() || p.y() > 200-p.z())
		{
		  p.x()=(drand48()-0.5)*1000;	
			p.y()=(drand48()-0.5)*1000;	
			p.z()=-800;
		}
 };


void GameIntro::Key(unsigned char key)
{
	switch(key){
		case ' ' : Game=&GS;
			GS.Init();
			GS.Reshape(ScreenW,ScreenH);
			break;
		}
}

void GameIntro::Init(int,int)
{
	float lp[4]={1,1,3,0};
	glLightfv(GL_LIGHT0,GL_POSITION,lp);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);
	//glEnable(GL_CULL_FACE);
	// Remove Comments if some face disappears...
	glDisable(GL_CULL_FACE);
	//glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	/* play the module file */  
  APlayModule(lpModule);
  ASetModuleVolume(8);
}

int GameIntro::Draw()
{ static float angle=0;
	int nt=0;
	glLoadIdentity();
	glPushMatrix();
	glColor3f(.7,.7,1);
	int sw=342; // subtitle width
	glPrintf(ScreenW/2-sw/2,ScreenH/3,20,"press space to start game");
	angle+=5.0;
	glRotatef(angle,0,1,0);
	glScalef(40,40,40);
	nt+=Title.DrawDL();
	glPopMatrix();
	glPushMatrix();
	glTranslatef(0,0,-1000);
	glScalef(2000,2000,2000);
	s.Draw();
  glPopMatrix();

	for(int i=0;i<AstNum;i++)
		 nt+=A[i]->Draw();
 return nt;
}

void  GameIntro::Reshape(int w,int h)
{
  ScreenW=w;
  ScreenH=h;
	int SpaceSize=100;
	float wr=float(w)/h;
  float hr=float(h)/w;

	if(w>h) hr=1;
	else wr=1;
  int VL = -SpaceSize*wr;
  int VR =  SpaceSize*wr;
  int VB = -SpaceSize*hr;
  int VT =  SpaceSize*hr;
  glViewport(0,0,w,h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

	gluPerspective(90,1,10,1201);
  gluLookAt(0,0,200,0,0,0,0,1,0);
	glMatrixMode(GL_MODELVIEW);
}

void GameIntro::Update(int dt)
{
	s.Update(dt);
	for(int i=0;i<AstNum;i++)
		{
		 A[i]->Update(dt);
		 Clip(A[i]->p);
		}
}